import java.util.*;
import java.lang.*;

public class BoggleEngineTester extends Tester {

	public static int getExpectedPointNumber(String word)
	{
		int length = word.length();
		
		if (length < 3)
			return 0;
		if (length >= 8)
			return 11;
		
		switch(word.length())
		{
			case 3:
			case 4:
				return 1;
			case 5:
				return 2;
			case 6:
				return 3;
			case 7:
				return 5;
		}
		
		return Integer.MIN_VALUE;
	}
	
	public void newBoardTester1() {
		BoggleEngine be = new BoggleEngine("words.txt");
		char[][] board1 = be.newBoard();
		char[][] board2 = be.newBoard();
		assert (Arrays.equals(board1, board2) == false);
		assert (board1.length == 4);
		assert (board1[0].length == 4);
		assert (board2.length == 4);
		assert (board2[0].length == 4);
	}
	
	public void newBoardTester2() {
		BoggleEngine be = new BoggleEngine("boggleDictionary.txt");
		char[][] board = 
		{ {'r', 'u', 't', 'r'},
			{'n', 's', 'w', 'e'},
			{'o', 't', 'j', 'e'},
			{'s', 'p', 'n', 'l'} };
		be.newBoard(board);
		assert (be.getPoints("sop") == getExpectedPointNumber("sop"));
		assert (be.getPoints("son") == getExpectedPointNumber("son"));
		assert (be.getPoints("opt") == getExpectedPointNumber("opt"));
	}
	
	public void iteratorTester() {
		BoggleEngine be = new BoggleEngine("boggleDictionary.txt");
		char[][] board = 
			{ {'r', 'u', 't', 'r'},
				{'n', 's', 'w', 'e'},
				{'o', 't', 'j', 'e'},
				{'s', 'p', 'n', 'l'} };
		be.newBoard(board);
		Iterator<String> it = be.getBoardWords();
		assert(it.hasNext() == true);
		assert("not".equals(it.next()));
		assert(it.hasNext() == true);
		assert("nut".equals(it.next()));
		assert(it.hasNext() == true);
	}

}
