import java.util.*;
import java.lang.*;

public class MyPrefixDictionaryTester extends Tester{
	
	private int MAX_WORD_LENGTH = 5;

	private MyPrefixDictionaryInterface myDictionary1() {
		return new MyPrefixDictionary1();
	}
	
	private MyPrefixDictionaryInterface myDictionary2() {
		return new MyPrefixDictionary2();
	}
	
	public MyPrefixDictionaryInterface addWords1(String dictionary) {
	   Scanner scanner = null;
		MyPrefixDictionaryInterface myDictionary = myDictionary1();
	   try { scanner = new Scanner(new java.io.File(dictionary)); }
	   catch (Exception e) {
	         System.out.println("File not found.");
	         System.exit(1);
	   }
	   while (scanner.hasNext()) {
	         String word = scanner.next();
	         if (word.length() < MAX_WORD_LENGTH)
	               myDictionary.addWord(word);
	   }
		return myDictionary;
	}
	
	public MyPrefixDictionaryInterface addWords2(String dictionary) {
	   Scanner scanner = null;
		MyPrefixDictionaryInterface myDictionary = myDictionary2();
	   try { scanner = new Scanner(new java.io.File(dictionary)); }
	   catch (Exception e) {
	         System.out.println("File not found.");
	         System.exit(1);
	   }
	   while (scanner.hasNext()) {
	         String word = scanner.next();
	         if (word.length() < MAX_WORD_LENGTH)
	               myDictionary.addWord(word);
	   }
		return myDictionary;
	}
	
	// Tests the smallest dictionary of only a few words
	public void tester11() {
		MAX_WORD_LENGTH = 1500; // No limit on the number of words
		MyPrefixDictionaryInterface dict = myDictionary1();
		dict = addWords1 ("words-small.txt");
		assert (dict.isPrefix("a") == true);
		assert (dict.isPrefix("aa") == true);
		assert (dict.isPrefix("aaa") == false);
		assert (dict.isPrefix("cal") == true);
		assert (dict.isPrefix("k") == false);
		assert (dict.isWord("gift") == true);
		assert (dict.isWord("world") == true);
		assert (dict.isWord("k") == false);
		dict.addWord("test");
		dict.addWord("lol");
		assert (dict.isWord("test") == true);
		assert (dict.isPrefix("tes") == true);
		assert (dict.isPrefix("lo") == true);
	}
	public void prefixTester1() {
		MyPrefixDictionaryInterface dict = myDictionary1();
		dict.addWord("abcd");
		dict.addWord("defg");
		dict.addWord("all");
		assert (dict.isPrefix("ab") == true);
		assert (dict.isPrefix("de") == true);
		assert (dict.isPrefix("abd") == false);
	}
	
	// Tests the smallest dictionary of only a few words
	public void tester12() {
		MAX_WORD_LENGTH = 1500; // No limit on the number of words
		MyPrefixDictionaryInterface dict = myDictionary2();
		dict = addWords2 ("words-small.txt");
		assert (dict.isPrefix("a") == true);
		assert (dict.isPrefix("aa") == true);
		assert (dict.isPrefix("aaa") == false);
		assert (dict.isPrefix("cal") == true);
		assert (dict.isWord("gift") == true);
		assert (dict.isWord("world") == true);
		assert (dict.isWord("k") == false);
		dict.addWord("test");
		dict.addWord("lol");
		assert (dict.isWord("test") == true);
		assert (dict.isPrefix("tes") == true);
		assert (dict.isPrefix("lo") == true);
	}
	
	public void wordTester2() {
		MyPrefixDictionaryInterface dict = myDictionary2();
		dict.addWord("abcd");
		dict.addWord("defg");
		dict.addWord("all");
		assert (dict.isWord("abcd") == true);
		assert (dict.isWord("defg") == true);
		assert (dict.isWord("abd") == false);
		assert (dict.isWord("all") == true);
	}
}
