import static java.lang.System.out;

public class Tester {
	// Find every public method named test...() and call it.
	// Assume these are void with no parameters.
	// Unexpected exceptions == failures.
	// Expected exceptions == successes (but then they MUST be thrown).
	// Print out each failed test.
	// Print out a final report on all tests.
	public void runTests() {
		out.printf("***\nTESTING: %s\n***\n",this.getClass().getName());
		int tests = 0, ok = 0;
		for (java.lang.reflect.Method method : this.getClass().getMethods())
			if (method.getName().startsWith("test")) {
				try {
					tests++;
					this.expectedExceptionName = null;
					this.runtime = null;
					//long startTime = System.currentTimeMillis();
					method.invoke(this);
					//long runTime = 
					if (this.expectedExceptionName == null)
						ok++;
					else {
						// we didn't get the exception we expected
						out.printf("Failed test: %s\n",method.getName());
						out.printf("      error: expected exception %s\n",
						           this.expectedExceptionName);
						out.println();
					}
				}
				catch (Throwable e) {
					if (e instanceof java.lang.reflect.InvocationTargetException)
						e = ((java.lang.reflect.InvocationTargetException) e)
						      .getTargetException();
					if ((this.expectedExceptionName != null) &&
						(e.getClass().getName().endsWith(this.expectedExceptionName)))
						// we got the exception we expected!
						ok++;
					else {
						StackTraceElement[] trace = e.getStackTrace();
						out.printf("Failed test: %s\n",method.getName());
						out.printf("      error: %s\n",e.toString());
						out.printf("   location: line %d of %s, method = %s.%s\n",
						           trace[0].getLineNumber(),
						           trace[0].getFileName(),
						           trace[0].getClassName(),
						           trace[0].getMethodName());
						out.println();
					}
				}
			}
		out.println("----------------------\nReport:");
		out.println("Total tests:     " + tests);
		out.println("Total successes: " + ok);
		out.println("Total failures:  " + (tests - ok));
		out.println("----------------------\n");
	}

	public void expectException(Exception e) {
		expectException(e.getClass().getName());
	}
	
	public void expectException(String exceptionName) {
		this.expectedExceptionName = exceptionName;
	}
	
	public void expectRuntime(String runtime){
		this.runtime = runtime;
	}
	
	private String expectedExceptionName;
	private String runtime;
	
	private final static String NLOGN = "O(nlogn)";
	private final static String N = "O(n)";
}